/* Linked list class implementation */
#include <cstdlib>
#include <iostream>
#include "List.h"
using namespace std;

/* Constructor */ 
List::List()
 { 
   headNode = new Node();
   headNode->setNext(NULL);
   currentNode = NULL;
   lastCurrentNode = NULL;
   size = 0;
 }

/* get studentID stored in currentnode */ 
string List::getID()
{
 if(currentNode!=NULL)
  return currentNode->getID();
}

/* get studentName stored in currentnode */ 
string List::getName()
{
 if(currentNode!=NULL)
  return currentNode->getName();
}

/* return the length of list */ 
int List::length()
{
 return size;
}   
 
/* position currentNode and lastCurrentNode at first element */
void List::start()
 {
  lastCurrentNode = headNode;
  currentNode = headNode->getNext();
 }

/* add node to the list */ 
void List::add(string id, string name)
{
 Node *newNode=new Node();
 newNode->set(id, name);
 
 if(currentNode != NULL) // list is not empty
 {
  newNode->setNext(currentNode->getNext());
  currentNode->setNext(newNode);
  lastCurrentNode=currentNode;
  currentNode=newNode;
 }
 else                 // list is empty
 {
  newNode->setNext(NULL);
  headNode->setNext(newNode);
  lastCurrentNode=headNode;
  currentNode=newNode;
  }
  size++;
}

/* search studentID from the list */ 
bool List:: searchByID(string id)
{
 Node *temp = currentNode;
 start();
 while(currentNode != NULL)
 {
  if(currentNode->getID() == id)
  {
   return true;
  }
  lastCurrentNode = currentNode;
  currentNode = currentNode->getNext();                  
 } //end while
 currentNode = temp;
 return false;
}

/* search studentName from the list */ 
bool List:: searchByName(string name)
{
 Node *temp = currentNode;
 start();
 while(currentNode != NULL)
 {
  if(currentNode->getName() == name)
  {
   return true;
  }
  lastCurrentNode = currentNode;
  currentNode = currentNode->getNext();                  
 } //end while
 currentNode = temp;
 return false;
}

/* remove node from the list */ 
void List:: remove()
{
 if(currentNode != NULL && size != 0)
 {
  lastCurrentNode->setNext(currentNode->getNext());
  delete currentNode;
  currentNode=lastCurrentNode->getNext();
  size--;
 }
}

/* print the list */ 
void List:: printList()
{
 Node *temp = currentNode;
 start();
 while(currentNode != NULL)
 {
  cout<<currentNode->getID()<<"\t"<<currentNode->getName()<<endl;
  currentNode = currentNode->getNext();
 }
 currentNode = temp;
}
